
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" /><meta name="generator" content="Docutils 0.17.1: http://docutils.sourceforge.net/" />

    <title>The Big Varnish Picture &#8212; Varnish version 6.0.11 documentation</title>
    <link rel="stylesheet" type="text/css" href="../_static/pygments.css" />
    <link rel="stylesheet" type="text/css" href="../_static/classic.css" />
    
    <script data-url_root="../" id="documentation_options" src="../_static/documentation_options.js"></script>
    <script src="../_static/jquery.js"></script>
    <script src="../_static/underscore.js"></script>
    <script src="../_static/doctools.js"></script>
    
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" />
    <link rel="next" title="Starting and running Varnish" href="running.html" />
    <link rel="prev" title="The Varnish Users Guide" href="index.html" /> 
  </head><body>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="running.html" title="Starting and running Varnish"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="index.html" title="The Varnish Users Guide"
             accesskey="P">previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../index.html">Varnish version 6.0.11 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="index.html" accesskey="U">The Varnish Users Guide</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href="">The Big Varnish Picture</a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <section id="the-big-varnish-picture">
<span id="users-intro"></span><h1>The Big Varnish Picture<a class="headerlink" href="#the-big-varnish-picture" title="Permalink to this headline">¶</a></h1>
<p>In this section we will cover answers to the questions:
- What is in this package called “Varnish”?
- what are all the different bits and pieces named?
- Will you need a hex-wrench for assembly?</p>
<p>The two main parts of Varnish are the two processes in the <cite>varnishd</cite>
program. The first process is called “the manager”, and its job is to
talk to you, the administrator, and make the things you ask for
happen.</p>
<p>The second process is called “the worker” or just “the child” and
this is the process which does all the actual work with your HTTP
traffic.</p>
<p>When you start <cite>varnishd</cite>, you start the manager process, and once it is
done handling all the command line flags, it will start the child
process for you. Should the child process die, the manager will start
it again for you, automatically and right away.</p>
<p>The main reason for this division of labor is security: The manager
process will typically run with “root” permissions, in order to
open TCP socket port 80, but it starts the child process with minimal
permissions, as a defensive measure.</p>
<p>The manager process is interactive, it offers a CLI – Command Line
Interface, which can be used manually, from scripts or programs. The
CLI offers almost full control of what Varnish actually does to your
HTTP traffic, and we have gone to great lengths to ensure that you
should not need to restart the Varnish processes, unless you need to
change something very fundamental.</p>
<p>The CLI can be safely accessed remotely, using a simple and flexible
PSK – Pre Shared Key, access control scheme, so it is easy to
integrate Varnish into your operations and management infrastructure
or tie it to your CMS.</p>
<p>All this is covered in <a class="reference internal" href="running.html#users-running"><span class="std std-ref">Starting and running Varnish</span></a>.</p>
<p>Things like, how the child process should deal with the HTTP requests, what to
cache, which headers to remove etc, is all specified using a small
programming language called VCL – Varnish Configuration Language.
The manager process will compile the VCL program and check it for
errors,</p>
<p>but it is the child process which runs the VCL program, for
each and every HTTP request which comes in.</p>
<p>Because the VCL is compiled to C code, and the C code is compiled
to machine instructions, even very complex VCL programs execute in
a few microseconds, without impacting performance at all.</p>
<p>And don’t fret if you are not really a programmer, VCL is very
simple to do simple things with:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">sub</span> <span class="n">vcl_recv</span> <span class="p">{</span>
        <span class="c1"># Remove the cookie header to enable caching</span>
        <span class="n">unset</span> <span class="n">req</span><span class="o">.</span><span class="n">http</span><span class="o">.</span><span class="n">cookie</span><span class="p">;</span>
<span class="p">}</span>
</pre></div>
</div>
<p>The CLI interface allows you to compile and load new VCL programs
at any time, and you can switch between the loaded VCL programs
instantly, without restarting the child process and without missing
a single HTTP request.</p>
<p>VCL code can be extended using external modules, called VMODs or
even by inline C-code if you are brave, so in terms of what Varnish
can do for your HTTP traffic, there really is no limit.</p>
<p><a class="reference internal" href="vcl.html#users-vcl"><span class="std std-ref">VCL - Varnish Configuration Language</span></a> describes VCL and what it can do in great detail.</p>
<p>Varnish uses a segment of shared memory to report and log its activities and
status. For each HTTP request, a number of very detailed records will
be appended to the log memory segment. Other processes
can subscribe to log-records, filter them, and format them, for
instance as Apache/NCSA style log records.</p>
<p>Another segment in shared memory is used for statistics counters,
this allows real-time, down to microsecond resolution monitoring
of cache hit-rate, resource usage and specific performance indicating
metrics.</p>
<p>Varnish comes with a number of tools which reports from shared
memory, <cite>varnishlog</cite>, <cite>varnishstats</cite>, <cite>varnishncsa</cite> etc, and with an API
library so you can write your own tools, should you need that.</p>
<p><a class="reference internal" href="report.html#users-report"><span class="std std-ref">Reporting and statistics</span></a> explains how all that work.</p>
<p>Presumably the reason for your interest in Varnish, is that you
want your website to work better. There are many aspects of
performance tuning a website, from relatively simple policy decisions
about what to cache, to designing a geographically diverse multilevel
CDNs using ESI and automatic failover.</p>
<p><a class="reference internal" href="performance.html#users-performance"><span class="std std-ref">Varnish and Website Performance</span></a> will take you through the possibilities
and facilities Varnish offers.</p>
<p>Finally, Murphys Law must be referenced here: Things will go wrong, and
more likely than not, they will do so at zero-zero-dark O’clock. Most
likely during a hurricane, when your phone battery is flat and your
wife had prepared a intimate evening to celebrate your anniversary.</p>
<p>Yes, we’ve all been there, haven’t we?</p>
<p>When things go wrong <a class="reference internal" href="troubleshooting.html#users-trouble"><span class="std std-ref">Troubleshooting Varnish</span></a> will hopefully be of some help.</p>
</section>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h4>Previous topic</h4>
  <p class="topless"><a href="index.html"
                        title="previous chapter">The Varnish Users Guide</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="running.html"
                        title="next chapter">Starting and running Varnish</a></p>
  <div role="note" aria-label="source link">
    <h3>This Page</h3>
    <ul class="this-page-menu">
      <li><a href="../_sources/users-guide/intro.rst.txt"
            rel="nofollow">Show Source</a></li>
    </ul>
   </div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false"/>
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="running.html" title="Starting and running Varnish"
             >next</a> |</li>
        <li class="right" >
          <a href="index.html" title="The Varnish Users Guide"
             >previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../index.html">Varnish version 6.0.11 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="index.html" >The Varnish Users Guide</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href="">The Big Varnish Picture</a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2010-2014, Varnish Software AS.
      Created using <a href="https://www.sphinx-doc.org/">Sphinx</a> 4.3.2.
    </div>
  </body>
</html>